# instantiate %genomicid2orgn
@organisms=qw/human pig chicken/;
@genomicid=qw/000001405 000003025 000002315/;
%genomicid2orgn=();
for($g=0;$g<scalar(@genomicid);$g++){
	$genomicid2orgn{$genomicid[$g]}=$organisms[$g];
}

# get all consensus seq id2length
%seqid2len=();
$infile="3S-targetSeqsFASTA.txt";
#$infile="5S-targetSeqsFASTA.txt";
@infilename=split(/\./,$infile);
open(IN0,$infile);
while(<IN0>){
	chomp($_);
	$_=~s/[\r\n]//g;
	if($_=~/^>/){
		$seqid=substr($_,1);
	}
	elsif($_ eq ""){
	}
	else{
		$seqid2len{$seqid}=length($_);
	}
}close(IN0);
$output2="humanrna-accessions_".$infile;
open(OUT2,">$output2");
%printedaccessions=();

# check human,pig,chicken transcriptome & genome for seqlen-100% matches e.g. seqid2humangenome, seqid2humanrna ...
@datafiles=<*.blastout>;
foreach $file (@datafiles){
	@filenameA=split(/\./,$file);
	@filenameB=split(/\_/,$filenameA[0]);
	$currgenomicid=$filenameB[scalar(@filenameB)-1];
	$currorgn=$genomicid2orgn{$currgenomicid};
	if($file=~/_genomic.fna/){
		$currhashname="seqid2".$currorgn."genomic";
		$currquery2hithashname="query2hitid_".$currorgn."genomic";
	}
	elsif($file=~/_rna.fna/){
		$currhashname="seqid2".$currorgn."rna";
		$currquery2hithashname="query2hitid_".$currorgn."rna";
	}
	%$currhashname=();
	%$currquery2hithashname=();
	open(IN,$file);
	while(<IN>){
		chomp($_);
		$_=~s/[\r\n]//g;
		@array=();
		@array=split(/\t/,$_);
		$queryseqid=$array[0];
		$hitseqid=$array[1];
		$percidentity=$array[2];
		$percidentity=int($percidentity);
		$alignlen=$array[3];
		$num_mismatches=$array[4];
		$num_gapopen=$array[5];
		if($alignlen==$seqid2len{$queryseqid}){
			if($percidentity==100){
				if($num_mismatches==0){
					if($num_gapopen==0){
						$$currhashname{$queryseqid}++;
						if($$currquery2hithashname{$queryseqid} eq ""){
							$$currquery2hithashname{$queryseqid}=$hitseqid;
							if($currquery2hithashname=~/humanrna/){
								@hitseqarray=split(/\./,$hitseqid);
								if($printedaccessions{$hitseqarray[0]} eq ""){
									print OUT2 "$hitseqarray[0]\n";
									$printedaccessions{$hitseqarray[0]}++;
								}
							}
						}
						else{
							@checkexist=();
							%forcheckexist=();
							@checkexist=split(/\|/,$$currquery2hithashname{$queryseqid});
							foreach $ce (@checkexist){
								$forcheckexist{$ce}++;
							}
							if($forcheckexist{$hitseqid} eq ""){
								$$currquery2hithashname{$queryseqid}=$$currquery2hithashname{$queryseqid}."|".$hitseqid;
								if($currquery2hithashname=~/humanrna/){
									@hitseqarray=split(/\./,$hitseqid);
									if($printedaccessions{$hitseqarray[0]} eq ""){
										print OUT2 "$hitseqarray[0]\n";
										$printedaccessions{$hitseqarray[0]}++;
									}
								}
							}
						}
					}
				}
			}
		}
	}close(IN);
}
$totalconsensus=0;
%hashname2matches=();
close(OUT2);

$output=$infilename[0]."_mapped-to-transcriptome-and-genome.txt";
open(OUT,">$output");
open(IN1,$infile);
while(<IN1>){
	chomp($_);
	$_=~s/[\r\n]//g;
	if($_=~/^>/){
		$totalconsensus++;
		$seqid=substr($_,1);
		print OUT "$seqid";
		for($orgn=0;$orgn<scalar(@organisms);$orgn++){
			$currorgn=$organisms[$orgn];
			# print transcriptome matches
			$thishashname="seqid2".$currorgn."rna";
			$thisquery2hithashname="query2hitid_".$currorgn."rna";
			if($$thishashname{$seqid} eq ""){
				print OUT "\t0";
				print OUT "\t";
			}
			elsif($$thishashname{$seqid} ne ""){
				print OUT "\t1";
				print OUT "\t$$thisquery2hithashname{$seqid}";
				$hashname2matches{$thishashname}++;
			}
			# print genome matches
			$thishashname="seqid2".$currorgn."genomic";
			$thisquery2hithashname="query2hitid_".$currorgn."genomic";
			if($$thishashname{$seqid} eq ""){
				print OUT "\t0";
				print OUT "\t";
			}
			elsif($$thishashname{$seqid} ne ""){
				print OUT "\t1";
				print OUT "\t$$thisquery2hithashname{$seqid}";
				$hashname2matches{$thishashname}++;
			}
		}
		print OUT "\n";
	}
}close(IN1);
close(OUT);

print "Total num consensus seq: $totalconsensus\n";
foreach $h (keys %hashname2matches){
	print "$h: $hashname2matches{$h}\n";
}
